require "thor"
require "bundler"
require "bundler/cli"

module BundleDepot
  class CLI < Thor
    def self.exit_on_failure?
      true
    end

    desc "fetch", "Fetch cached bundle package from remote storage"
    long_desc <<-D
      Bacon ipsum dolor sit amet fatback rump frankfurter ball tip pork
      meatball. Sausage hamburger bacon short ribs, meatball ball tip biltong
      tenderloin bresaola rump pastrami turkey kevin flank.
    D
    def fetch 
      BundleDepot::Cache.new.fetch
    rescue GemfileNotFound
      say "Couldn't find Gemfile.lock"
      exit 1
    end

    desc "store", "Store bundle to remote location"
    long_desc <<-D
      Bacon ipsum dolor sit amet fatback rump frankfurter ball tip pork
      meatball. Sausage hamburger bacon short ribs, meatball ball tip biltong
      tenderloin bresaola rump pastrami turkey kevin flank.
    D
    def store
      BundleDepot::Cache.new.store
    rescue GemfileNotFound
      say "Couldn't find Gemfile.lock"
      exit 1
    rescue BundleNotFound
      say "Couldn't find the cached bundle. Please run 'bundle-depot fetch' before calling this command..."
      exit 2
    rescue RemoteConfigurationMissing
      say "Remote cache is not configured. Configured the SCP environment variables to run 'bundle-depot store'"
      exit 3
    end
  end
end
